/**************************************************************************/
/* GenerateIndex.h - global stuff                                         */
/**************************************************************************/

#include "defs.h"
#include "protos.h"

#define VERSION "1.1"
#define DATE "(" __COMMODORE_DATE__ ")"

/* Value passed to CloseAll() when a text is also passed */
#define ERROR_SPECIAL 1

extern struct List FileList;
extern ULONG Options;
extern struct rtFileRequester *DataFileReq;

extern STRPTR InitialFile;
extern UBYTE DataName[108];

enum Arguments { FROM, TO, SETTINGS,
                 RECURSIVELY, KEEPEMPTY, UNRECOGAREDOCS,
                 AUTODOC,
                 CINC, C_DEFINE, C_STRUCT, C_TYPEDEF,
                 EINC, E_CONST, E_OBJECT, E_PROC,
                 ASMINC, ASM_EQU, ASM_STRUCTURE, ASM_MACRO,

                 LAST_ARGUMENT /* used to find sizeof */
               };

enum FileTypes { FILE_UNKNOWN, FILE_AUTODOC, FILE_C, FILE_E, FILE_ASM };

enum UnknownFiles { UNKNOWN_ARE_IGNORED, UNKNOWN_ARE_AUTODOCS };

struct FileEntry {
    struct Node node;

char afternode[];
    struct List RefsList;
    UBYTE Name[];
};

struct RefsEntry {
   struct Node node;
  
char afternode[];
   LONG Offset;
   LONG Length;
   WORD Goto;
   UBYTE Name[];
};

struct Prefs {
    struct {
        BYTE Active;
    } AutoDocPrf;

    struct {
        BYTE Active;
        BYTE Define;
        BYTE Struct;
        BYTE Typedef;
    } CPrf;

    struct {
        BYTE Active;
        BYTE Const;
        BYTE Object;
        BYTE Proc;
    } EPrf;

    struct {
        BYTE Active;
        BYTE Equ;
        BYTE Structure;
        BYTE Macro;
    } AsmPrf;

    BYTE Recursively;
    BYTE KeepEmpty;
    BYTE UnknownFiles;
};
extern struct Prefs Settings;

enum {
    WINDOW_MAIN_ID = 1,
    WINDOW_EDIT_ID,
    WINDOW_OPTIONS_ID,

    MAIN_MENU_PROJECT_CLEAR,
    MAIN_MENU_PROJECT_LOAD,
    MAIN_MENU_PROJECT_SAVE,
    MAIN_MENU_PROJECT_OPTIONS,
    MAIN_MENU_PROJECT_ABOUT,
    MAIN_MENU_PROJECT_QUIT,

    MAIN_LIST_ID,
    MAIN_REFERENCES_ID,
    MAIN_ADD_ID,
    MAIN_EDIT_ID,
    MAIN_RESCAN_ID,
    MAIN_DELETE_ID,

    EDIT_LIST_ID,
    EDIT_NAME_ID,
    EDIT_FILE_ID,
    EDIT_OFFSET_ID,
    EDIT_LENGTH_ID,
    EDIT_GOTO_ID,
    EDIT_OKAY_ID,
    EDIT_DELETE_ID,

    OPTIONS_MENU_PROJECT_OPEN_ID,
    OPTIONS_MENU_PROJECT_SAVEAS_ID,

    OPTIONS_AUTODOC_ID,
    
    OPTIONS_C_ID,
    OPTIONS_C_DEFINE_ID,
    OPTIONS_C_STRUCT_ID,
    OPTIONS_C_TYPEDEF_ID,

    OPTIONS_E_ID,
    OPTIONS_E_CONST_ID,
    OPTIONS_E_OBJECT_ID,
    OPTIONS_E_PROC_ID,

    OPTIONS_ASM_ID,
    OPTIONS_ASM_EQU_ID,
    OPTIONS_ASM_STRUCTURE_ID,
    OPTIONS_ASM_MACRO_ID,

    OPTIONS_RECURSIVELY_ID,
    OPTIONS_KEEPEMPTY_ID,
    OPTIONS_UNKNOWNFILES_ID,

    OPTIONS_SAVE_ID,
    OPTIONS_USE_ID,
    OPTIONS_CANCEL_ID,
};

